#ifndef _H_C7BD43BD5A4AFEC392BF4F224E0573AF_PositionCmd_DCPS_H_
#define _H_C7BD43BD5A4AFEC392BF4F224E0573AF_PositionCmd_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "PositionCmd_.h"


namespace kartech_linear_actuator_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class PositionCmd_TypeSupportInterface;

            typedef PositionCmd_TypeSupportInterface * PositionCmd_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PositionCmd_TypeSupportInterface> PositionCmd_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PositionCmd_TypeSupportInterface> PositionCmd_TypeSupportInterface_out;


            class PositionCmd_DataWriter;

            typedef PositionCmd_DataWriter * PositionCmd_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PositionCmd_DataWriter> PositionCmd_DataWriter_var;
            typedef DDS_DCPSInterface_out < PositionCmd_DataWriter> PositionCmd_DataWriter_out;


            class PositionCmd_DataReader;

            typedef PositionCmd_DataReader * PositionCmd_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PositionCmd_DataReader> PositionCmd_DataReader_var;
            typedef DDS_DCPSInterface_out < PositionCmd_DataReader> PositionCmd_DataReader_out;


            class PositionCmd_DataReaderView;

            typedef PositionCmd_DataReaderView * PositionCmd_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PositionCmd_DataReaderView> PositionCmd_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PositionCmd_DataReaderView> PositionCmd_DataReaderView_out;

            struct PositionCmd_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < PositionCmd_, struct PositionCmd_Seq_uniq_> PositionCmd_Seq;
            typedef DDS_DCPSSequence_var < PositionCmd_Seq> PositionCmd_Seq_var;
            typedef DDS_DCPSSequence_out < PositionCmd_Seq> PositionCmd_Seq_out;

            class  PositionCmd_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PositionCmd_TypeSupportInterface_ptr _ptr_type;
                typedef PositionCmd_TypeSupportInterface_var _var_type;

                static PositionCmd_TypeSupportInterface_ptr _duplicate (PositionCmd_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionCmd_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PositionCmd_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionCmd_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionCmd_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PositionCmd_TypeSupportInterface () {};
                ~PositionCmd_TypeSupportInterface () {};
            private:
                PositionCmd_TypeSupportInterface (const PositionCmd_TypeSupportInterface &);
                PositionCmd_TypeSupportInterface & operator = (const PositionCmd_TypeSupportInterface &);
            };

            class  PositionCmd_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PositionCmd_DataWriter_ptr _ptr_type;
                typedef PositionCmd_DataWriter_var _var_type;

                static PositionCmd_DataWriter_ptr _duplicate (PositionCmd_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionCmd_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PositionCmd_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionCmd_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionCmd_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PositionCmd_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PositionCmd_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PositionCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PositionCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PositionCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PositionCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PositionCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PositionCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PositionCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PositionCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PositionCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PositionCmd_& instance_data) = 0;

            protected:
                PositionCmd_DataWriter () {};
                ~PositionCmd_DataWriter () {};
            private:
                PositionCmd_DataWriter (const PositionCmd_DataWriter &);
                PositionCmd_DataWriter & operator = (const PositionCmd_DataWriter &);
            };

            class  PositionCmd_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PositionCmd_DataReader_ptr _ptr_type;
                typedef PositionCmd_DataReader_var _var_type;

                static PositionCmd_DataReader_ptr _duplicate (PositionCmd_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionCmd_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PositionCmd_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionCmd_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionCmd_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PositionCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PositionCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PositionCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PositionCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PositionCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PositionCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PositionCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PositionCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PositionCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PositionCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PositionCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PositionCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PositionCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PositionCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PositionCmd_& instance) = 0;

            protected:
                PositionCmd_DataReader () {};
                ~PositionCmd_DataReader () {};
            private:
                PositionCmd_DataReader (const PositionCmd_DataReader &);
                PositionCmd_DataReader & operator = (const PositionCmd_DataReader &);
            };

            class  PositionCmd_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PositionCmd_DataReaderView_ptr _ptr_type;
                typedef PositionCmd_DataReaderView_var _var_type;

                static PositionCmd_DataReaderView_ptr _duplicate (PositionCmd_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionCmd_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PositionCmd_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionCmd_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionCmd_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PositionCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PositionCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PositionCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PositionCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PositionCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PositionCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PositionCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PositionCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PositionCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PositionCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PositionCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PositionCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PositionCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PositionCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PositionCmd_& instance) = 0;

            protected:
                PositionCmd_DataReaderView () {};
                ~PositionCmd_DataReaderView () {};
            private:
                PositionCmd_DataReaderView (const PositionCmd_DataReaderView &);
                PositionCmd_DataReaderView & operator = (const PositionCmd_DataReaderView &);
            };
        }

    }

}

#endif
