#ifndef _H_F9B92DF4D7E3596E3A128878BFC8098B_ReportIndex_DCPS_H_
#define _H_F9B92DF4D7E3596E3A128878BFC8098B_ReportIndex_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ReportIndex_.h"


namespace kartech_linear_actuator_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ReportIndex_TypeSupportInterface;

            typedef ReportIndex_TypeSupportInterface * ReportIndex_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ReportIndex_TypeSupportInterface> ReportIndex_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ReportIndex_TypeSupportInterface> ReportIndex_TypeSupportInterface_out;


            class ReportIndex_DataWriter;

            typedef ReportIndex_DataWriter * ReportIndex_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ReportIndex_DataWriter> ReportIndex_DataWriter_var;
            typedef DDS_DCPSInterface_out < ReportIndex_DataWriter> ReportIndex_DataWriter_out;


            class ReportIndex_DataReader;

            typedef ReportIndex_DataReader * ReportIndex_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ReportIndex_DataReader> ReportIndex_DataReader_var;
            typedef DDS_DCPSInterface_out < ReportIndex_DataReader> ReportIndex_DataReader_out;


            class ReportIndex_DataReaderView;

            typedef ReportIndex_DataReaderView * ReportIndex_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ReportIndex_DataReaderView> ReportIndex_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ReportIndex_DataReaderView> ReportIndex_DataReaderView_out;

            struct ReportIndex_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ReportIndex_, struct ReportIndex_Seq_uniq_> ReportIndex_Seq;
            typedef DDS_DCPSSequence_var < ReportIndex_Seq> ReportIndex_Seq_var;
            typedef DDS_DCPSSequence_out < ReportIndex_Seq> ReportIndex_Seq_out;

            class  ReportIndex_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ReportIndex_TypeSupportInterface_ptr _ptr_type;
                typedef ReportIndex_TypeSupportInterface_var _var_type;

                static ReportIndex_TypeSupportInterface_ptr _duplicate (ReportIndex_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ReportIndex_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ReportIndex_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ReportIndex_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ReportIndex_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ReportIndex_TypeSupportInterface () {};
                ~ReportIndex_TypeSupportInterface () {};
            private:
                ReportIndex_TypeSupportInterface (const ReportIndex_TypeSupportInterface &);
                ReportIndex_TypeSupportInterface & operator = (const ReportIndex_TypeSupportInterface &);
            };

            class  ReportIndex_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ReportIndex_DataWriter_ptr _ptr_type;
                typedef ReportIndex_DataWriter_var _var_type;

                static ReportIndex_DataWriter_ptr _duplicate (ReportIndex_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ReportIndex_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ReportIndex_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ReportIndex_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ReportIndex_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ReportIndex_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ReportIndex_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ReportIndex_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ReportIndex_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ReportIndex_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ReportIndex_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ReportIndex_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ReportIndex_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ReportIndex_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ReportIndex_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ReportIndex_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ReportIndex_& instance_data) = 0;

            protected:
                ReportIndex_DataWriter () {};
                ~ReportIndex_DataWriter () {};
            private:
                ReportIndex_DataWriter (const ReportIndex_DataWriter &);
                ReportIndex_DataWriter & operator = (const ReportIndex_DataWriter &);
            };

            class  ReportIndex_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ReportIndex_DataReader_ptr _ptr_type;
                typedef ReportIndex_DataReader_var _var_type;

                static ReportIndex_DataReader_ptr _duplicate (ReportIndex_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ReportIndex_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ReportIndex_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ReportIndex_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ReportIndex_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ReportIndex_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ReportIndex_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ReportIndex_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ReportIndex_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ReportIndex_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ReportIndex_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ReportIndex_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ReportIndex_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ReportIndex_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ReportIndex_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ReportIndex_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ReportIndex_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ReportIndex_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ReportIndex_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ReportIndex_& instance) = 0;

            protected:
                ReportIndex_DataReader () {};
                ~ReportIndex_DataReader () {};
            private:
                ReportIndex_DataReader (const ReportIndex_DataReader &);
                ReportIndex_DataReader & operator = (const ReportIndex_DataReader &);
            };

            class  ReportIndex_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ReportIndex_DataReaderView_ptr _ptr_type;
                typedef ReportIndex_DataReaderView_var _var_type;

                static ReportIndex_DataReaderView_ptr _duplicate (ReportIndex_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ReportIndex_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ReportIndex_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ReportIndex_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ReportIndex_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ReportIndex_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ReportIndex_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ReportIndex_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ReportIndex_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ReportIndex_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ReportIndex_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ReportIndex_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ReportIndex_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ReportIndex_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ReportIndex_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ReportIndex_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ReportIndex_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ReportIndex_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ReportIndex_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ReportIndex_& instance) = 0;

            protected:
                ReportIndex_DataReaderView () {};
                ~ReportIndex_DataReaderView () {};
            private:
                ReportIndex_DataReaderView (const ReportIndex_DataReaderView &);
                ReportIndex_DataReaderView & operator = (const ReportIndex_DataReaderView &);
            };
        }

    }

}

#endif
